'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Network adaptor for Hack the Valley GraphQL
 * Author: Jun Zheng
 * License: MIT
 */

var Adaptor = require('./Adaptor');
var ApolloLink = require('../links/synchronouslinks/ApolloLink');

var HackTheValleyApolloAdaptor = function (_Adaptor) {
    _inherits(HackTheValleyApolloAdaptor, _Adaptor);

    function HackTheValleyApolloAdaptor(config) {
        _classCallCheck(this, HackTheValleyApolloAdaptor);

        var _this = _possibleConstructorReturn(this, (HackTheValleyApolloAdaptor.__proto__ || Object.getPrototypeOf(HackTheValleyApolloAdaptor)).call(this, config));

        _this._apolloLink = new ApolloLink(config.apolloEndpoint);
        return _this;
    }

    _createClass(HackTheValleyApolloAdaptor, [{
        key: 'setAuthenticationToken',
        value: function setAuthenticationToken(token) {
            this._apolloLink = new ApolloLink(this._config.apolloEndpoint, {
                headers: {
                    authorization: "Bearer " + token
                }
            });
        }
    }, {
        key: 'setApolloEndpoint',
        value: function setApolloEndpoint(url) {
            this._apolloLink = new ApolloLink(url);
            this._config.apolloEndpoint = url;
        }
    }, {
        key: 'query',
        value: function query(_query) {
            var variables = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

            return this._apolloLink.query({ query: _query, variables: variables });
        }
    }, {
        key: 'mutate',
        value: function mutate(query) {
            var variables = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

            return this._apolloLink.mutate({ query: query, variables: variables });
        }
    }]);

    return HackTheValleyApolloAdaptor;
}(Adaptor);

module.exports = HackTheValleyApolloAdaptor;