"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var HackerApplicationController = function () {
    function HackerApplicationController(app) {
        _classCallCheck(this, HackerApplicationController);

        this.app = app;
        this.create = this.create.bind(this);
        this.updateQuestion = this.updateQuestion.bind(this);
        this.submit = this.submit.bind(this);
    }

    /**
     * Create a new hacker hacker application, return hacker application ID if successful
     * @param application_id
     * @returns {Promise<any>}
     */


    _createClass(HackerApplicationController, [{
        key: "create",
        value: function create(application_id) {
            var _this = this;

            return new Promise(function (resolve, reject) {
                var mutationString = "\n                mutation createHackerApplication($application_id: String!) {\n                    createHackerApplication(application_id: $application_id) {\n                        _id\n                    }\n                }\n            ";
                _this.app.getAdaptor().mutate(mutationString, {
                    application_id: application_id
                }).then(function (result) {
                    resolve(result.createHackerApplication._id);
                }).catch(function (e) {
                    reject(e);
                });
            });
        }

        /**
         * Update an existing hacker application
         * @param hacker_application_id
         * @param question_id
         * @param answer
         * @returns {Promise<any>}
         */

    }, {
        key: "updateQuestion",
        value: function updateQuestion(hacker_application_id, question_id, answer) {
            var _this2 = this;

            return new Promise(function (resolve, reject) {
                var mutationString = "\n                mutation updateHackerApplicationAnswer ($hacker_application_id: String!, $question_id: String!, $answer: [String]!) {\n                    updateHackerApplicationAnswer(hacker_application_id: $hacker_application_id, question_id: $question_id, answer: $answer) {\n                        _id\n                    }\n                }\n            ";
                _this2.app.getAdaptor().mutate(mutationString, {
                    hacker_application_id: hacker_application_id, question_id: question_id, answer: answer
                }).then(function (result) {
                    resolve(result.updateHackerApplicationAnswer._id);
                }).catch(function (e) {
                    reject(e);
                });
            });
        }

        /**
         * Mark an application as submitted
         * @param hacker_application_id
         * @returns {Promise<any>}
         */

    }, {
        key: "submit",
        value: function submit(hacker_application_id) {
            var _this3 = this;

            return new Promise(function (resolve, reject) {
                var mutationString = "\n                mutation submitHackerApplication($hacker_application_id: String!) {\n                    submitHackerApplication(hacker_application_id: $hacker_application_id) {\n                        _id\n                    }\n                }\n            ";
                _this3.app.getAdaptor().mutate(mutationString, {
                    hacker_application_id: hacker_application_id
                }).then(function (result) {
                    resolve(result.submitHackerApplication._id);
                }).catch(function (e) {
                    reject(e);
                });
            });
        }
    }]);

    return HackerApplicationController;
}();

module.exports = HackerApplicationController;