"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var HackerController = function () {
    function HackerController(app) {
        var _this = this;

        _classCallCheck(this, HackerController);

        this.sendPasswordResetEmail = async function (email_address) {
            var result = await _this.app.getAdaptor().mutate("\n            mutation sendHackerPasswordResetEmail ($email_address: String!) {\n                sendHackerPasswordResetEmail(email_address: $email_address)\n            }\n        ", {
                email_address: email_address
            });
            return result.sendHackerPasswordResetEmail;
        };

        this.resetPassword = async function (email_address, code, new_password) {
            var result = await _this.app.getAdaptor().mutate("\n            mutation resetHackerPassword ($email_address: String!, $code: String!, $new_password: String!) {\n                resetHackerPassword (email_address: $email_address, code: $code, new_password: $new_password) {\n                    _id\n                }\n            }\n        ", {
                email_address: email_address, code: code, new_password: new_password
            });
            return result.resetHackerPassword._id;
        };

        this.app = app;
        this.create = this.create.bind(this);
        this.update = this.update.bind(this);
        this.createToken = this.createToken.bind(this);
    }

    /**
     * Create a new hacker, return hacker ID if successful
     * @param email_address
     * @param password
     * @returns {Promise<any>}
     */


    _createClass(HackerController, [{
        key: "create",
        value: function create(email_address, password) {
            var _this2 = this;

            return new Promise(function (resolve, reject) {
                var mutationString = "\n                mutation createHacker ($email_address: String!, $password: String!) {\n                    createHacker(email_address: $email_address, password: $password) {\n                        _id\n                    }\n                }\n            ";
                _this2.app.getAdaptor().mutate(mutationString, {
                    email_address: email_address, password: password
                }).then(function (result) {
                    resolve(result.createHacker._id);
                }).catch(function (e) {
                    reject(e);
                });
            });
        }

        /**
         * Create a new hacker token
         * @param email_address
         * @param password
         * @param expire_after
         * @returns {Promise<any>}
         */

    }, {
        key: "createToken",
        value: function createToken(email_address, password) {
            var _this3 = this;

            var expire_after = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 86400;

            return new Promise(function (resolve, reject) {
                var mutationString = "\n                mutation createHackerToken ($email_address: String!, $password: String!, $expire_after: Int) {\n                    createHackerToken(email_address: $email_address, password: $password, expire_after: $expire_after) {\n                        token_body\n                    }\n                }\n            ";
                _this3.app.getAdaptor().mutate(mutationString, {
                    email_address: email_address, password: password, expire_after: expire_after
                }).then(function (result) {
                    resolve(result.createHackerToken.token_body);
                }).catch(function (e) {
                    reject(e);
                });
            });
        }

        /**
         * Update an existing hacker
         * @param id
         * @param hacker
         * @returns {Promise<any>}
         */

    }, {
        key: "update",
        value: function update(id, hacker) {
            var _this4 = this;

            return new Promise(function (resolve, reject) {
                var mutationString = "\n                mutation updateHacker ($id: String!, $hacker: UpdateHackerInput!) {\n                    updateHacker(id: $id, hacker: $hacker) {\n                        _id\n                    }\n                }\n            ";
                _this4.app.getAdaptor().mutate(mutationString, {
                    id: id, hacker: hacker
                }).then(function (result) {
                    resolve(result.updateHacker._id);
                }).catch(function (e) {
                    reject(e);
                });
            });
        }
    }]);

    return HackerController;
}();

module.exports = HackerController;