"use strict";

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var UserController = function UserController(app) {
    var _this = this;

    _classCallCheck(this, UserController);

    this.createToken = async function (username, password) {
        var expire_after = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 86400;

        var result = await _this.app.getAdaptor().mutate("\n            mutation createUserToken ($username: String!, $password: String!, $expire_after: Int) {\n                createUserToken(username: $username, password: $password, expire_after: $expire_after) {\n                    token_body\n                }\n            }\n        ", {
            username: username, password: password, expire_after: expire_after
        });
        return result.createUserToken.token_body;
    };

    this.app = app;
}

/**
 * Create a new user token
 * @param username
 * @param password
 * @param expire_after
 * @returns {Promise<any>}
 */
;

module.exports = UserController;